#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define EXPORT32  extern "C" __declspec(dllexport)

#define MAX_VALUES   10

static int m_Value = 0;
static int m_Values[MAX_VALUES] = {0};
static char m_ansi[100] = {0};
static wchar_t m_unicode[100] = {0};

EXPORT32 void _stdcall TestFunction()
// einfacher Aufruf einer Prozedur
{
   MessageBox(NULL, L"Hallo World", L"Caption", MB_OK);
}

EXPORT32 BOOL _stdcall SetValue(int value)
// bergabe einer beliebigen Integer-Zahl
{
   m_Value = value;
   return TRUE;
}

EXPORT32 BOOL _stdcall GetValue(int* pIntValue)
// Auslesen einer Integer-Zahl
{
   if(pIntValue == NULL)
   {
      return FALSE;
   }
   *pIntValue = m_Value;
   return TRUE;
}

EXPORT32 BOOL _stdcall SetValues(int* pIntValues, int number)
// bergabe eines Integer-Arrays
{
   if(pIntValues == NULL)
   {
      return FALSE;
   }
   if(::IsBadReadPtr(pIntValues, number * sizeof(int)))
   {
      return FALSE;
   }
   if(number > MAX_VALUES)
   {
      return FALSE;
   }
   for(int i = 0; i < number; i++)
   {
      m_Values[i] = pIntValues[i];
   }
   return TRUE;
}

EXPORT32 BOOL _stdcall GetValues(int* pIntValues, int number)
// Auslesen des Integer-Arrays
{
   if(pIntValues == NULL)
   {
      return FALSE;
   }
   if(::IsBadWritePtr(pIntValues, number * sizeof(int)))
   {
      return FALSE;
   }
   if(number > MAX_VALUES)
   {
      return FALSE;
   }
   for(int i = 0; i < number; i++)
   {
      pIntValues[i] = m_Values[i];
   }
   return TRUE;
}

EXPORT32 BOOL _stdcall SetStringAnsi(char* pszText)
// bergabe eines ANSI-Strings
{
   if(pszText == NULL)
   {
      return FALSE;
   }
   int number = strlen(pszText);
   if(number >= sizeof(m_ansi))
   {
      return FALSE;
   }
   if(number == 0)
   {
      m_ansi[0] = 0;
   }
   memcpy(m_ansi, pszText, (number + 1) * sizeof(char));
   return TRUE;
}

EXPORT32 BOOL _stdcall GetStringAnsi(char** ppszText)
// Auslesen eines ANSI-Strings
{
   if(ppszText == NULL)
   {
      return FALSE;
   }
   if(m_ansi[0] == 0)
   {
      *ppszText = "Hallo World (Ansi)";
   }
   else
   {
      *ppszText = m_ansi;
   }
   return TRUE;
}

EXPORT32 BOOL _stdcall SetStringUnicode(wchar_t* pszText)
// bergabe eines Unicode-Strings
{
   if(pszText == NULL)
   {
      return FALSE;
   }
   int number = wcslen(pszText);
   if(number >= sizeof(m_unicode))
   {
      return FALSE;
   }
   if(number == 0)
   {
      m_unicode[0] = 0;
   }
   memcpy(m_unicode, pszText, (number + 1) * sizeof(wchar_t));
   return TRUE;
}

EXPORT32 BOOL _stdcall GetStringUnicode(wchar_t** ppszText)
// Auslesen eines Unicode-Strings
{
   if(ppszText == NULL)
   {
      return FALSE;
   }
   if(m_unicode[0] == 0)
   {
      *ppszText = L"Hallo World (Unicode)";
   }
   else
   {
      *ppszText = m_unicode;
   }
   return TRUE;
}
